#include "stringArrayList.h"
#include <iostream>

using namespace std;

stringArrayList::stringArrayList(int capacity){
		std::cout << "stringArrayList construction is running...\n"; 
		listArray_ = new string[capacity]; 
		n_=0; 
		capacity_ = capacity;
	}
	
bool stringArrayList::empty() const{return n_==0;};
	
int stringArrayList::count() const{return n_;}
	
void stringArrayList::print() const{ 
		for (int i=0; i<n_; i++) 
			std::cout << listArray_[i] << " ";
		std::cout << std::endl;
	}

bool stringArrayList::removeFirst(const string& elem){
		int index = findFirst(elem); 
		if (index==-1){
			std::cout << "removing " << elem << " failed!\n";
			return false;
		}
		for (int i=index; i<n_-1; i++)
			listArray_[i] = listArray_[i+1];
		n_--;	
		std::cout << "just removed " << elem << std::endl;
		return true;	
	}

bool stringArrayList::add(const string& new_entry){
		if (n_+1 > capacity_){ // array is full
			std::cout << "adding " << new_entry << " failed\n";
			return false;
		}
		listArray_[n_] = new_entry;
		n_++;
		std::cout << "just added " << new_entry << std::endl; 
		return true;
	}

stringArrayList::~stringArrayList() {
		std::cout << "stringArrayList destruction is running...\n";
		delete [] listArray_; 
	}

int stringArrayList::findFirst(const string& elem) const{
		for (int i=0; i<n_; i++)
			if (listArray_[i] == elem)
				return i;
		return -1;
	}

