#include <iostream>
#include "stringSortedArrayList.h"

using namespace std;

stringSortedArrayList::stringSortedArrayList(int capacity): stringArrayList(capacity) {
		std::cout << "stringSortedArrayList construction is running...\n";
	}

bool stringSortedArrayList::add(const string& elem){
		if (n_+1> capacity_){
			std::cout << "adding " << elem << " failed!" << std::endl;
			return false;
		}
	
		int right_place = getRightPlace(elem);
		// shift everything right
		for (int i=n_-1; i>=right_place; i--)
			listArray_[i+1] = listArray_[i];

		listArray_[right_place] = elem;
		n_++;		

		std::cout << "just added " << elem << std::endl;
		return true;
	}

bool stringSortedArrayList::fastSearch(const string& elem){
		return binarySearch(elem, 0, n_-1);			
	}

stringSortedArrayList::~stringSortedArrayList(){
		std::cout << "stringSortedArrayList destruction is running...\n";
	}

int stringSortedArrayList::getRightPlace(const string& elem){
		for (int i=0; i<n_; i++)
			if (listArray_[i]>= elem)
				return i;
		return n_;
	}

bool stringSortedArrayList::binarySearch(const string& elem, int start_index, int end_index){
		if (start_index > end_index)
			return false;
		int middle_index = (start_index + end_index)/2;
		if (listArray_[middle_index]>elem)
			return binarySearch(elem, start_index, middle_index-1);
		else if (listArray_[middle_index]<elem)
			return binarySearch(elem, middle_index+1, end_index);
		else // listArray_[middle_index]==elem
			return true; 
	}
